// --------------------------------------------------------------------------------------
// 
// DivGraph.CS                                                     Ulrich Mller 21.01.05
//                                                                 PCS1700   C# Final SP2
// Einfache Graphiken mit C# - .NET
//
// Allgemeines Koordinaten-System Pixel, Ecke links oben = 0,0
//
// --------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DivGraph
{
	public class frmMain : System.Windows.Forms.Form {
		private System.Windows.Forms.PictureBox picAus;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Panel pnlParm;
		private System.Windows.Forms.ListBox lstAuswahl;
		private System.Drawing.Printing.PrintDocument prtAus;
		private System.Windows.Forms.Button cmdDrucken;
		private System.ComponentModel.Container components = null;

		public frmMain() {
			InitializeComponent();
			lstAuswahl.SelectedIndex = 1;
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent() {
			this.picAus = new System.Windows.Forms.PictureBox();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.pnlParm = new System.Windows.Forms.Panel();
			this.lstAuswahl = new System.Windows.Forms.ListBox();
			this.cmdDrucken = new System.Windows.Forms.Button();
			this.prtAus = new System.Drawing.Printing.PrintDocument();
			this.SuspendLayout();
			// 
			// picAus
			// 
			this.picAus.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.picAus.BackColor = System.Drawing.Color.White;
			this.picAus.Location = new System.Drawing.Point(24, 24);
			this.picAus.Name = "picAus";
			this.picAus.Size = new System.Drawing.Size(500, 500);
			this.picAus.TabIndex = 0;
			this.picAus.TabStop = false;
			this.picAus.Paint += new System.Windows.Forms.PaintEventHandler(this.picAus_Paint);
			// 
			// cmdAction
			// 
			this.cmdAction.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdAction.Location = new System.Drawing.Point(544, 488);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(136, 32);
			this.cmdAction.TabIndex = 1;
			this.cmdAction.Text = "&Anzeigen";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cmdEnde
			// 
			this.cmdEnde.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Location = new System.Drawing.Point(544, 408);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(136, 32);
			this.cmdEnde.TabIndex = 2;
			this.cmdEnde.Text = "&ENDE";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// pnlParm
			// 
			this.pnlParm.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pnlParm.Location = new System.Drawing.Point(544, 240);
			this.pnlParm.Name = "pnlParm";
			this.pnlParm.Size = new System.Drawing.Size(136, 104);
			this.pnlParm.TabIndex = 3;
			// 
			// lstAuswahl
			// 
			this.lstAuswahl.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.lstAuswahl.Items.AddRange(new object[] {
															"Pythagoras",
															"Hilbert",
															"Sierpinski",
															"FarbQuadrate",
															"Lissajous",
															"TurtleDemo",
															"TurtleRose",
															"TurtleZigZag",
															"TurtleSierpiinski",
															"TurtleVierBier"});
			this.lstAuswahl.Location = new System.Drawing.Point(544, 32);
			this.lstAuswahl.Name = "lstAuswahl";
			this.lstAuswahl.Size = new System.Drawing.Size(136, 186);
			this.lstAuswahl.TabIndex = 4;
			this.lstAuswahl.DoubleClick += new System.EventHandler(this.lstAuswahl_DoubleClick);
			// 
			// cmdDrucken
			// 
			this.cmdDrucken.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdDrucken.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdDrucken.Location = new System.Drawing.Point(544, 448);
			this.cmdDrucken.Name = "cmdDrucken";
			this.cmdDrucken.Size = new System.Drawing.Size(136, 32);
			this.cmdDrucken.TabIndex = 5;
			this.cmdDrucken.Text = "&Drucken";
			this.cmdDrucken.Click += new System.EventHandler(this.cmdDrucken_Click);
			// 
			// prtAus
			// 
			this.prtAus.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.prtAus_PrintPage);
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(696, 549);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdDrucken,
																		  this.lstAuswahl,
																		  this.pnlParm,
																		  this.cmdEnde,
																		  this.cmdAction,
																		  this.picAus});
			this.Name = "frmMain";
			this.Text = "C# - .NET : Einfache Graphiken";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new frmMain());
		}


		// --- cmdEnde_Click : Programmende ---------------------------------------
		private void cmdEnde_Click(object sender, System.EventArgs e) {
			this.Close();
		}

		// --- cmdAction_Click : Anzeige der ber lstAuswahl gewhlten Seite ----
		//                       teilweise mit Zufallswerten.
		private void cmdAction_Click(object sender, System.EventArgs e) {
			ShowGraf(sender, picAus.CreateGraphics());
		}
		// --- lstAuswahl_DoubleClick : Anzeige der gewhlten Graphik ---------------
		private void lstAuswahl_DoubleClick(object sender, System.EventArgs e) {
			ShowGraf(sender, picAus.CreateGraphics());		
		}

		// --- picAus_Paint : Neuzeichnen nach Verdeckung ------------------------
		private void picAus_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			ShowGraf(sender, e.Graphics);
		}

		// --- cmdDrucken : Start Drucken --------------------------------------------
		private void cmdDrucken_Click(object sender, System.EventArgs e) {
			prtAus.Print();		
		}
		// --- prtAus_PrintPage : Drucken einer Seite im Kontext mit prtAus.Print() ---
		private void prtAus_PrintPage(object sender, 
			System.Drawing.Printing.PrintPageEventArgs e) {
			ShowGraf(sender, e.Graphics);
		}

		// --- ShowGraf : Anzeige der ber lstAuswahl gewhlten Graphik -----------
		//                alternativ auch Druck, dabei wird die Graphik um 150/150 auf
		//                der Seite nach rechts/unten verschoben. Hintergrund sollte immer
		//                White sein, da er ganzseitig gedruckt wird
		//
		private void ShowGraf(object sender, Graphics g) {
			switch (lstAuswahl.SelectedIndex) {
				case 0:
					Pythagoras pythagoras = new Pythagoras(picAus);
					pythagoras.Stift = new Pen(Color.Blue, 1);
					pythagoras.TanPi = 1.0F;
					if(sender.GetType().Name == "PrintDocument") {
						pythagoras.Background = Color.White;
						g.TranslateTransform(150, 150);}
					else {pythagoras.Background = Color.AntiqueWhite;}
					pythagoras.Action(g);
					break;
				case 1:
					Hilbert hilbert = new Hilbert(picAus);
					hilbert.Stift = new Pen(Color.Blue, 1);
					hilbert.Tiefe = 5;
					hilbert.Breite = 450;
					if(sender.GetType().Name == "PrintDocument") {
						hilbert.Background = Color.White;
						g.TranslateTransform(150, 150);}
					else {hilbert.Background = Color.AntiqueWhite;}
					hilbert.Action(g);
					break;
				case 2:
					Sierpinski sierpinski = new Sierpinski(picAus);
					sierpinski.Tiefe = 5;
					sierpinski.Breite = 640;
					if(sender.GetType().Name == "PrintDocument") {
						sierpinski.Background = Color.White;
						g.TranslateTransform(150, 150);}
					else {sierpinski.Background = Color.AntiqueWhite;}
					sierpinski.Action(g);
					break;
				case 3:
					FarbQuadrate farbQuadrate = new FarbQuadrate(picAus);
					farbQuadrate.Anzahl = 32;
					if(sender.GetType().Name == "PrintDocument") {
						farbQuadrate.Background = Color.White;
						g.TranslateTransform(150, 150);}
					else {farbQuadrate.Background = Color.AntiqueWhite;}
					farbQuadrate.Action(g);
					break;
				case 4:
					Lissajous lissajous = new Lissajous(picAus);
					if(sender.GetType().Name == "PrintDocument") {
						lissajous.Background = Color.White;
						g.TranslateTransform(150, 150);}
					else {lissajous.Background = Color.AntiqueWhite;}
					lissajous.Action(g);
					break;
				case 5:
					TurtleDemo turtleDemo = new TurtleDemo(picAus);
					if(sender.GetType().Name == "PrintDocument") {
						turtleDemo.Background(Color.White);
						g.TranslateTransform(150, 150);}
					else {turtleDemo.Background(Color.Bisque);}
					turtleDemo.Action(g);
					break;
				case 6:
					TurtleRose turtleRose = new TurtleRose(picAus);
					if(sender.GetType().Name == "PrintDocument") {
						turtleRose.Background(Color.White);
						g.TranslateTransform(150, 150);}
					else {turtleRose.Background(Color.Bisque);}
					turtleRose.Action(g);
					break;
				case 7:
					TurtleZigZag turtleZigZag = new TurtleZigZag(picAus);
					if(sender.GetType().Name == "PrintDocument") {
						turtleZigZag.Background(Color.White);
						g.TranslateTransform(150, 150);}
					else {turtleZigZag.Background(Color.Bisque);}
					turtleZigZag.Action(g);
					break;
				case 8:
					TurtleSierpinski turtleSier = new TurtleSierpinski(picAus);
					if(sender.GetType().Name == "PrintDocument") {
						turtleSier.Background(Color.White);
						g.TranslateTransform(150, 150);}
					else {turtleSier.Background(Color.Bisque);}
					turtleSier.Action(g);
					break;
				case 9:
					TurtleVierBier turtleVier = new TurtleVierBier(picAus);
					if(sender.GetType().Name == "PrintDocument") {
						turtleVier.Background(Color.White);
						g.TranslateTransform(150, 150);}
					else {turtleVier.Background(Color.Bisque);}
					turtleVier.Action(g);
					break;
			}
		}
	}
}
