// --------------------------------------------------------------------------------------
//
// FarbQuadrate.CS                                                 Ulrich Mller 24.01.05
//                                                                 PCS1700       C# Final
// Gefllte Rechtecke mit zuflliger Anordnung, Farbe und Gre
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph {
	public class FarbQuadrate : UrGraf {

		const int maxBreite = 180;
		const int maxHoehe  = 140;

		SolidBrush Farbe;
		Random     rnd = new Random();
		int        X0, Y0, XB, YH;
		int        anzahl = 28;

		public FarbQuadrate(Control Ausgabe) : base(Ausgabe) {
		}
		public int Anzahl {
			get{return anzahl;}
			set{anzahl = value;}
		}
		public override void Action(Graphics Canvas) {
			base.canvas = Canvas;
			base.canvas.Clear(base.background);
			for(int i = 0; i < anzahl; i++) {
				Farbe = new SolidBrush(Color.FromArgb(rnd.Next(0,255), 
					rnd.Next(0,255), rnd.Next(0,255)));
				X0 = rnd.Next(40, ausgabe.Width - maxBreite);
				Y0 = rnd.Next(30, ausgabe.Height - maxHoehe);
				XB = rnd.Next(40, maxBreite);
				YH = rnd.Next(32, maxHoehe);
				canvas.FillRectangle(Farbe, X0, Y0, XB, YH);
			}
		}
	}
}
