// --------------------------------------------------------------------------------------
//
// TurtleDemo.CS                                                   Ulrich Mller 27.01.05
//                                                                 PCS1700       C# Final
// Demo der in Klasse Turtle implementierten Methoden
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class TurtleDemo	: Turtle {
		public TurtleDemo(Control Ausgabe) : base(Ausgabe) {}

		public void Action(Graphics Canvas) {
			Bild(Canvas);
			StiftAb();
			Schachtelei(4);
			SetXY(-100, -100);
			Figur4();
		}
		private void Schachtelei(int N) {
			if(N < 1) return;
			Figur();
			Figur();
			Links(90);
			Schachtelei(N-1);
		}
		private void Figur4() {
			for(int i = 0; i < 4; i++) {Figur();}
		}
		private void Figur() {
			Vorwaerts(40); Rechts(90);
			Vorwaerts(40); Rechts(90);
			Vorwaerts(20); Rechts(90);
			Vorwaerts(20); Rechts(90);
			Vorwaerts(40); Rechts(90);
			Vorwaerts(10); Rechts(90);
			Vorwaerts(10); Rechts(90);
			Vorwaerts(20); 
		}
	}
}
