// --------------------------------------------------------------------------------------
//
// TurtleRose.CS                                                   Ulrich Mller 27.01.05
//                                                                 PCS1700       C# Final
// Logo - Rose 
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class TurtleRose : Turtle {
		public TurtleRose(Control Ausgabe) : base(Ausgabe) {}

		public void Action(Graphics Canvas) {
			Bild(Canvas);
			Canvas.ScaleTransform(2, 2);
			StiftAb();
			PenColor(Color.Purple);
			Rose();
		}

		private void Vau() {
			Left(45);
			Forward(10);
			Back(10);
			Right(90);
			Forward(10);
			Back(10);
			Links(45);
		}
		private void Zweig() {
			Forward(15);
			Vau();
			Forward(15);
			Vau();
			Forward(10);
			Back(40);
		}
		private void Busch() {
			Left(60);
			for(int i = 0; i < 6; i++) {Zweig(); Right(20);}
			Zweig();
			Left(60);
		}
		private void Baum() {
			Forward(35);
			Busch();
			Back(35);
		}
		private void Rose() {
			for(int i=0; i<6; i++) {Baum(); Right(60);}
			Rechts(30);
			Forward(60);
			for(int i=0; i<6; i++) {Busch(); Back(60); Right(60); Forward(60);}
			Home();
			AufKurs(0);
		}
	}
}
