// --------------------------------------------------------------------------------------
//
// TurtleVierBier.CS                                               Ulrich Mller 31.01.05
//                                                                 PCS1700       C# Final
// Viereck-Graphik im Auto Demo-Mode
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class TurtleVierBier	: Turtle {
		private float Kante, Delta, ZufX, ZufY;
		private int anzQ, anzS;

		public TurtleVierBier(Control Ausgabe) : base(Ausgabe) {}

		public void Action(Graphics Canvas) {
			Kante = 100;
			anzQ  = 9;
			anzS  = 4;
			Delta = Kante / anzQ;
			Draw(Canvas);
			AufXY(-200, -200);
			StarteZufall();
			ZufY = Zufallszahl(5);
			ZufX = Zufallszahl(5);
			SerieX(anzS);
		}

		private void Quadrat(float Kante) {
			StiftAb();
			for(int i = 0; i < 4; i++) {Vorwaerts(Kante); Rechts(90);}
			StiftHoch();
		}
		private void Schachtel(float Kante, int anzQ) {
			if(anzQ == 0) return;
			Quadrat(Kante);
			AufXY(XKo()+Delta/2-ZufX, YKo()+Delta/2-ZufY);
			Schachtel(Kante-Delta, anzQ-1);
			AufXY(XKo()-Delta/2+ZufX, YKo()-Delta/2+ZufY);
		}
		private void SerieX(int anzSX) {
			if(anzSX == 0) return;
			SerieY(anzS);
			AufX(XKo()+Kante);
			SerieX(anzSX-1);
			AufX(XKo()-Kante);
		}
		private void SerieY(int anzSY) {
			if(anzSY == 0) return;
			Schachtel(Kante, anzQ); 
			AufY(YKo()+Kante);
			SerieY(anzSY-1);
			AufY(YKo()-Kante);
		}
	}
}
