// --------------------------------------------------------------------------------------
//
// TurtleZigZag.CS                                                 Ulrich Mller 27.01.05
//                                                                 PCS1700       C# Final
// Logo ZigZag Graphik
//
// --------------------------------------------------------------------------------------

using System;
using System.Windows.Forms;
using System.Drawing;

namespace DivGraph
{
	public class TurtleZigZag : Turtle {
		public TurtleZigZag(Control Ausgabe) : base(Ausgabe){}
			private float Breite = 300;
			private float Hoehe  = 300;
			private int   anzZ   = 13;
			private float Delta;
			private float YBasis = -150;

		public void Action(Graphics Canvas) {
			Delta  = Hoehe/(anzZ - 1);
			Draw(Canvas);
			PenUp();
			SetXY(-150, YBasis);
			ZigZag(anzZ, anzZ);
		}
		private void ZigZag(int anzL, int anzR) {
			if(anzL == 0) return;
			SetY(YBasis + (anzL-1)*Delta);
			StrichBuendel(anzR, YCor());
			ZigZag(anzL-1, anzR);
		}
		private void StrichBuendel(int anzR, float Yact) {
			if(anzR == 0) return;
			PenDown(); SetXY(XCor()+Breite, YBasis+(anzR-1)*Delta); PenUp();
			SetXY(XCor()-Breite, Yact);
			StrichBuendel(anzR-1, Yact);
		}
	}
}
